;  Diamond Hunter - Made by Zaifrun of Immaculate in 1998 (Martin Knudsen)
;  This is my contribution to the 256-bytes digger/boulderdash compo by Gnome
;  Contact: Zaifrun@EarthCorp.com         
;  Compile with : "Tasm thesnake /m2"                                       
;  Link with    : "Tlink thesnake /t"                                       
;  I used Tasm 4.0 and Tlink 6.0 to make this game.
;  Video mode = 40x25 in 16 colors                                          
;  Current code size = 255 bytes.              
																		
ideal                                                                       
model tiny                                                                  
p386                            ; I use fs
									    
;------------------------------                                             
; Here goes some constants....
;------------------------------                                             
  bptr equ byte ptr
  wptr equ word ptr                                                          
									     
									     
  Player1up     = 72            ; Cursor keys for player                     
  Player1Left   = 75            ; These are scan codes for                   
  Player1Right  = 77            ; the arrow keys                             
  Player1Down   = 80            ; But they are not used - takes 2 bytes more
				
  Player2Up     = 'i'           ; alternative keys for player 1 (ascii codes)    
  Player2Down   = 'k'             
  Player2Left   = 'j'             
  Player2Right  = 'l'                    
  Player1Start  = 80*1+4        ; Player one start offset in video ram     
									   
									    
  PlayerAscii   = 1             ; Different ascii codes
  SandAscii     = 3                                                         
  DiamondAscii  = 4                                                         
  RockAscii     = 15                                                       
  BorderAscii   = 32                                                        
									    
  PlayerCode    = PlayerAscii+(2)*256                                       
  RockCode      = RockAscii+(0*16+6)*256                                    
  DiamondCode   = DiamondAscii+(0*16+14)*256                                
  BorderCode    = BorderAscii+(4*16+4)*256                                  
  SandCode      = SandAscii+(7*16+7)*256                                    
  RocksPerLevel = Player1Start                                             
  DiamondsToGet = 12            ; Change this to make it harder on yourself
										
  Active        = 1                
  NotActive     = 0                                                                                                                                                                             
 
  ; regs used int the code
  ; si = player offset                                                       
  ; cl = Nr of diamonds collected = 0 from the start
  ; ch = ScanScreen time  
  ; dx = 0              
  ; bp = time counter   
  ; ax = temp reg       
  ; di,bx = used in scan loop
  ; fs = number of stones 
  ; es,ds = pointer to text screen memory           
	
	
										
codeseg                                                                     
  org 100h                      ; Start at 100h to make a com file          
  startupcode                   ; The code starts here                      
;---------------------
; Do some initializing
;---------------------      
  cwd                           ; Makes dx = 0 - Thanks Aquanaut!
  mov  fs,dx                                                      
  mov  al,1h                    ; ah should be zero from the start
  int  10h              
  push 0B800h                   ; set up seg regs to text memory
  pop  es                                                       
  push es                                                       
  pop  ds                                                       
 @restartgame:                                                                                                                                  
;--------------------
; Setup the screen
;--------------------
  xor  di,di                    
  mov  ax,SandCode              ; draw everything in sand color
  mov  ch,4           
  rep  stosw            
  mov  si,RocksPerLevel         ; now place randomly rocks and diamonds                                                                         
  mov  cx,fs                    ; increase number of rocks on the level
  add  cx,si                                                           
  mov  fs,cx                                                           
									     
  mov  bp,11101111110b          ; Make sure the rocks are inside the
 @PlaceThings:                  ; border by ANDing with 2046-128.
  in   al,40h                   ; read LSB from timer
  sub  bx,ax            
  xor  ax,bx                    ; Just to make further randomness
  and  ax,bp                                                     
  xchg ax,di                    ; I just love those 1 byte mnemonics
  mov  [wptr di],RockCode       ; Place a rock
  cmp  cx,40                    ; or a diamond...
  jae  @okay2           
  mov  [wptr di],DiamondCode    ; Diamond this time.
 @okay2:
  loop  @PlaceThings    
									     
;---------------------------------                                           
; Drawing the border color is next                                           
;---------------------------------
				 
  mov  ax,BorderCode             
  xor  di,di                    ; set to start of screen
  mov  cl,39                               
  rep  stosw                    ; Draw upper horizontal line      
  mov  cl,22                
@Doagain:                                                                    
  mov  [di],ax           
  mov  [di+2],ax         
  add  di,80                    ; Avoid a segment override because ds=textmem
  loop @Doagain                 ; Done??                                                                                        
  mov  cl,41               
  rep  stosw                    ; Do the last horizontal border
									     
@mainloop:                                                                   
  mov  [wptr si],PlayerCode     ; Draw player
			    
  cmp  cl,DiamondsToGet         ; enough diamonds to go to next level???                
  jae   short @restartgame      
  
;-----------------------------------------------------------------
; Update falling rocks and diamonds!                              
; Use a scan technique to check everything.                       
; This is the most space consuming piece of code (around 75 bytes)
; ----------------------------------------------------------------
							   
  test  ch,15                   ; Only update some times
  jnz  short @NoScan  
  inc  bp                       ; Increase time counter 
  pusha                                                
  mov  di,2000                  ; start scan from bottom of screen
  mov  bp,di         
 @scan:                 
  mov  cx,2        
  mov  ax,[di]                  ; Save the old thing
  test al,4                     ; stone or diamond??
  jz   @nope                    ; it was not a stone or diamond
  mov  bx,80
  cmp  [bptr di+bx],PlayerAscii ; place below = player ?
  ja   @somebelow               ; stone, sand or diamond below
  jne   short @MakeMove  
  cmp  [bptr di+bp],dl          ; NotActive 
  jne   short @makemove         
									 
 @SomeBelow:                                                            
  mov  [bptr di+bp],dl          ; Set the old position to inactive
  cmp  [bptr di+bx],cl          ; If you want change cl with '3' - this
				; will prevent things from going to the side
				; if there is sand below them - like the
				; original - uses 1 extra byte - so I could
				; have done it - but this is more challenging
  jbe   @nope                   ; Player under so no one moves
  mov  bx,cx           
  cmp  [bptr di+bx],dl          ; Can we go the side??
  jne  @CheckOther                                    
  cmp  [bptr di+82],dl                                
  je   @makemove                                      
 @CheckOther:
  neg   bx             
  cmp  [bptr di+bx],dl   
  jne  @nope        
  cmp  [bptr di+78],dl
  jne   @nope     
  inc  cx                       ; move to +2
  inc  cx                                                         
 @MakeMove:                                                       
  mov  [di],dx                  ; Delete old positon - set to zero
  mov  [di+bx+2000],al          ; set new point to active
  mov  [di+bx],ax               ; move to new place
 @nope:               
  sub   di,cx   
  jnz  @scan    
  popa               
 @NoScan:                                                         
								  
;-----------------------                                                     
; Screen Synchronization                                                     
;-----------------------                                                     
  pusha                                                           
  mov  ah,86h                   ; shorter than use vertical retrace
  xor  cx,cx                    ; only uses 9 bytes - vertical retrace
  mov  dh,51                    ; takes 13 bytes to do            
  mov  [es:bp+1],dh             ; Draw time counter               
  int  15h                      ; Besides retrace will not always be
  popa                          ; 70Hz in textmode 1,2 and 3 under win95
				; At least not on my graphics card
  inc  ch                       ; Increase update counter
  cmp  bp,25*80      
  jae  short @quit              ; time out!
						     
  cmp  [bptr si],PlayerAscii    ; Is the player dead.
  jne  short @quit              ; Yep!  
;------------------                                                          
; check for new key                                                          
;------------------ 
  mov  ah,1                     ; use bios
  int  16h                      ; to see if ANY key has been pressed
  jz   short @mainloop          ; nope - continue the main loop
									     
;---------------------                                                       
; Effects of a new key                                                       
;---------------------                                                       
  xor  ah,ah                    ; read the new key
  int  16h                      ; using bios
  cmp  al,27                    ; check for escape (code 27)
  je   short @quit              ; quit game                                  
 
;---------------------------
; Change direction of player
;---------------------------
  mov  [wptr si],dx             ; erase old position of player
  mov  bx,si          
  cmp  al,player2left           ; compare keys  
  ja   @rightdown     
  je   @left1         
  sub  si,78          
 @left1:           
  sub  si,82          
 @rightdown:                                                                  
  cmp  al,player2Right  
  je   @right1          
  add  si,78            
 @right1:                                                                     
  inc  si               
  inc  si               
 @next4:
 
;----------------                                                       
; collision check
;----------------
  cmp  [bptr si],DiamondAscii   
  jbe   @Noborder               
  mov  si,bx                    ; No - we cannot move through rocks
 @NoBorder:                                                        
  jne  @NoDiamond                                      
  inc  cx                       ; Collected a new diamond
 @NoDiamond:                                             
  jmp  @mainloop                ; long jump (more than 127) - takes 3 bytes
 @Quit:                                                      
  mov  ax,3h                    ; Set textmode (80x25x16C) 
  int  10h                      ; using bios               
  ret                           ; Go back to OS
					      
end                             ; It's all over........... for this time!!            
   
